/*
 * Test program for the BASIL ENGINE-type "QUERY" method
 */
#include "basil_alps.h"
#include "cmdline.h"

int main(int argc, char **argv)
{
	struct gengetopt_args_info args;
	
	if (cmdline_parser(argc, argv, &args) != 0)
		return EXIT_FAILURE;

	if (args.basil_flag) {
		enum basil_version version = get_basil_version();

		printf("%s\n", bv_names[version]);
	} else { /* args.engine_flag */
		const char *alps_engine = get_alps_engine();
	
		if (alps_engine == NULL)
			return EXIT_FAILURE;
		printf("ALPS engine version '%s'\n", alps_engine);
	}

	return EXIT_SUCCESS;
}

